class Result<V, E> {
  V _value;
  E _error;

  Result([this._value, this._error]);

  bool get hasValue => _value != null;

  V get value {
    if (_value == null) throw new Exception("value cannot be null");

    return _value;
  }

  E get error {
    if (_error == null) throw new Exception("error cannot be null");

    return _error;
  }

  static Result<LV, LE> of<LV, LE>(LV value) => new Result(value);

  static Result<LV, LE> ofError<LV, LE>(LE error) => new Result(null, error);
}
