import "package:dotenv/dotenv.dart";
import "package:travis_dart/travis.dart";

void main() {
  load();

  var api = new Travis(env["TRAVIS_API_TOKEN"]);

  api.getUser().then((u) {
    if (u.hasValue) {
      print("Login: ${u.value.login}");
    } else {
      print("Name errors: ${u.error.errorMessage}");
    }
  });

  api.getRepository(18808936).then((r) {
    if (r.hasValue)
      print("Description: ${r.value.name} - ${r.value.description}");
    else
      print("Description Error: ${r.error.errorMessage}");
  });

  api.getRepositories().then((r) {
    if (r.hasValue) {
      print("Repositories:");
      r.value.repositories.forEach((r) => print("${r.name} - ${r.id}"));
    } else {
      print("Repositories Error: ${r.error.errorMessage}");
    }
  });

  api.getOrganizations().then((r) {
    if (r.hasValue) {
      print("Organizations:");
      r.value.organizations.forEach((o) => print(o.name));
    } else {
      print("Organizations Error: ${r.error.errorMessage}");
    }
  }); 
  
}